yes, we need stable update